function [InPacket ErrorFlag] = getXBeePacket(COM)
%get XBee API mode 2 packets


NUM_DATA_SETS = 5;
DATA_PER_SET = 2;
ADDITIONAL_NUMS = 5;
DATA_ARRAY_LENGTH = NUM_DATA_SETS*DATA_PER_SET+ADDITIONAL_NUMS;
BYTES_PER_DATUM = 4;


verifysum = 0;
ErrorFlag = 0;
InPacket = struct('length',0,...
    'API_ID',0,...
    'source',0,...
    'RSSI',0,...
    'options',0,...
    'data', double(zeros(1,DATA_ARRAY_LENGTH)),...
    'checksum',0);
if (COM.BytesAvailable > 0)
    start = fread(COM,1,'uint8');
    if (start ~= 126)
        disp('start delimiter wrong');
        while (start~=126) %126 = 0x7E
            if (COM.BytesAvailable > 0)
                start = fread(COM,1);
                disp('byte burned');
            end
        end
    end
    lengthH = loadbyte(COM);
    lengthL = loadbyte(COM);
    InPacket.length = lengthH*256 + lengthL; 
    InPacket.API_ID = loadbyte(COM);
    sourceH = loadbyte(COM);
    sourceL = loadbyte(COM);
    InPacket.source = sourceH*256 + sourceL;
    InPacket.RSSI = loadbyte(COM);
    InPacket.options = loadbyte(COM);
    
    %Get four bytes
    for i = 1:DATA_ARRAY_LENGTH
        bytes = uint8(zeros(1,4));
        for j = 1:4
            bytes(j) = loadbyte(COM);
        end
        verifysum = verifysum + double(sum(bytes));
        InPacket.data(i) = double(fourChar2Float(bytes));
    end
    InPacket.checksum = loadbyte(COM);
    verifysum = verifysum +...
                double(InPacket.API_ID) + ...
                double(InPacket.source)+ ...
                double(InPacket.RSSI) +...
                double(InPacket.options) +...
                double(InPacket.checksum);
            
    check = mod(verifysum,256);
    if check ~= 255
        ErrorFlag = 1;
        disp('checksum incorrect!');
    end
else
    disp('no data in buffer');
end
end